Subject: bug#68334: 29.1; tool-bar-make-keymap-1 does not work on terminals

From: Eli Zaretskii <[email-masked]>
Date: Tue, 09 Jan 2024 20:57:35 +0200

> From: Stefan Kangas <[email-masked]>
> Date: Tue, 9 Jan 2024 10:39:05 -0800
> Cc: [email-masked], [email-masked]
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> > Context:  I am writing a package that displays toolbars attached to an
> >> > Emacs window instead of attached to the frame.  You can see the package
> >> > at <https://github.com/chaosemer/window-tool-bar>.
> >>
> >> Shouldn't this be a feature in core Emacs?  I believe that we have
> >> discussed that in the past.
> >>
> >> Eli, WDYT?
> >
> > I won't mind, if Jared thinks the package will be useful in enough
> > situations or for enough packages.
> 
> I didn't intend to propose including the existing implementation as is,
> which I hadn't looked closely at.  Having done that just now, it seems
> like it's implemented on the tab bar, as Juri has pointed out.  I think
> this is probably not the right thing for a feature in Emacs itself.

How else do you expect this to be implemented on TTY frames?  It can
either overwrite parts of the menu bar, or it could overwrite parts of
the tab bar.  Something's gotta give, no?

I also don't understand why the tab bar is deemed more important than
the tool bar.  Let's let users decide what they prefer.  (Of course,
if there's a way to let them have the cake and eat it, too, that would
be the best.)

> This feature would be most useful as a first class feature, but that
> might require C changes.

IMO, usurping one more screen line from TTY frames could be
problematic, especially on terminals that display a relatively small
number of lines.